#include "mex.h"
#include <stdint.h>

void sum_grad(double * grad, uint32_t * lut, uint32_t * V0, uint32_t * q, int length, double gL) {

	int i;
	double cost;

	cost = 0;
	for(i = 0; i < length; i++)
		grad[lut[V0[i]-1]+q[i]-1] += gL;
}


/* grad = backward(v0,q,lut,gL,sz) */
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) {

	int length,nillum,sz,i,QQ;

	double * gL, * grad;
	uint32_t * lut, * v0, * q;

	const mwSize * dims;
	mwSize odims[1];

	v0 = mxGetData(prhs[0]);
	q = mxGetData(prhs[1]);
	lut = mxGetData(prhs[2]);
	gL = mxGetPr(prhs[3]);

	dims = mxGetDimensions(prhs[0]);
	length = dims[0]; if(length == 1) length = dims[1];

	dims = mxGetDimensions(prhs[2]);
	QQ = dims[0]; nillum = dims[1];

	sz = (int)mxGetScalar(prhs[4]);

	odims[0] = sz;
	plhs[0] = mxCreateNumericArray(1, odims, mxDOUBLE_CLASS, mxREAL);
	grad = mxGetPr(plhs[0]);

	for(i = 0; i < nillum; i++)
		sum_grad(grad,&lut[QQ*i],v0,q,length,gL[i]);
}
