#include "mex.h"
#include <stdint.h>
#include <omp.h>

#define NUMT 16


double sum_cost(double * chl, uint32_t * lut, uint32_t * V0, uint32_t * q, int length) {

	int i;
	double cost;

	cost = 0;
	for(i = 0; i < length; i++)
		cost += chl[lut[V0[i]-1]+q[i]-1];

	return cost / ((double)length);
}


/* costs = forward(v0,q,lut,chl) */
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) {

	int length,nillum,QQ;

	double * chl, * cost;
	uint32_t * lut, * v0, * q;

	const mwSize * dims;
	mwSize odims[1];

	v0 = mxGetData(prhs[0]);
	q = mxGetData(prhs[1]);
	lut = mxGetData(prhs[2]);
	chl = mxGetPr(prhs[3]);

	dims = mxGetDimensions(prhs[0]);
	length = dims[0]; if(length == 1) length = dims[1];


	dims = mxGetDimensions(prhs[2]);
	QQ = dims[0]; nillum = dims[1];

	odims[0] = nillum;
	plhs[0] = mxCreateNumericArray(1, odims, mxDOUBLE_CLASS, mxREAL);
	cost = mxGetPr(plhs[0]);


	omp_set_num_threads(NUMT);
#pragma omp parallel 
	{
		int i = omp_get_thread_num(); 
		for(; i < nillum; i+=NUMT)
			cost[i] = sum_cost(chl,&lut[QQ*i],v0,q,length);
	}

}
