function ch = getCHist(idx,Q,LQ)

ch = zeros(Q*Q*LQ,1);
idx = sort(idx);

for i = idx
  fprintf('\r getCHist: %03d  ',i);
  
  [img,corr,mask] = loadImg(i);
  V = polarC(corr,Q);
  
  mask = mask & max(img,[],3) < 0.95 & min(img,[],3) > 0;
  
  q = mean(img,3); q = q / median(q(mask == 1)) / 4;
  q = min(LQ-1,floor(q*LQ));
  V = uint32(V(mask == 1) + q(mask == 1)*Q*Q);
  ch = ch + hist(V,[1:Q*Q*LQ])';
end;

ch = reshape(ch,[Q*Q LQ]);

ch = log(1+ch); ch = bsxfun(@minus,ch,max(ch,[],1));
ch = bsxfun(@minus,ch,log(sum(exp(ch),1)));

fprintf('\n');