function [errs,ells] = meanErr(costs,f,ul,prior,true)

true = bsxfun(@rdivide,true,sqrt(sum(true.^2,2)));

errs = zeros(length(costs),1);

if length(f) == 1
  f = f*ones(length(costs),1);
end;

ells = zeros(length(costs),3);

for i = 1:length(costs)

  cost = costs{i}*f(i) + prior;
  cost = cost - max(cost);
  cost = exp(cost);
  cost = cost / sum(cost);
  
  est = sum(bsxfun(@times,ul,cost),1);
  est = est / sqrt(sum(est.^2));
  ells(i,:) = est;
  
  err = acosd(min(1,sum(est.*true(i,:))));
  %fprintf('%d: Err = %.4f\n',i,err);
  errs(i) = err;
end;